# 屏幕刷新率

屏幕刷新率代表眼镜屏幕每秒的刷新次数，通常屏幕刷新率与应用支持的最高帧率相同。例如，屏幕刷新率为 72 Hz 时，应用的最高帧率为 72 FPS。屏幕刷新率越高，画面刷新越快，画面流畅度和稳定性越好。但是，高屏幕刷新率也会对设备性能产生一定影响，当应用无法达到设备的最高刷新率时，可能会导致掉帧、卡顿、撕裂、延迟等问题。

默认情况下，我们鼓励应用将屏幕刷新率设定为 90 Hz，以提供更好的用户体验，仅当特殊需求时才将屏幕刷新率设定为 72 Hz，如：
- 性能不足、电量消耗过大时：你可以通过 你可以使用[实时监控工具](https://developer.pfdm.cn/yvrdoc/unity_CN/UserManual_CN/MetricsTool.html)监控应用性能，确保应用可以承受高屏幕刷新率。详情可参考性能监控与分析。
- 当播放视频时：如果视频帧率与屏幕刷新率不匹配，可能会导致视觉上的不连续、顿挫感。如视频是 24 hz 的，而屏幕刷新率设定为 90 HZ。因为 24Hz 的视频帧率无法均匀地分布在 90Hz 的刷新率上，导致每一帧的在屏幕上显示的时间不一样，从而产生视觉上的卡顿感，因此建议在播放视频时切换到适合的屏幕刷新率。

## 设置屏幕刷新率

通过 `YVRManager.instance.cameraRenderer.displayFrequency` 设置屏幕刷新率，如下所示：

```csharp
YVRManager.instance.cameraRenderer.displayFrequency = 90;
```

你可以在应用启动时设置屏幕刷新率，也可以在应用运行时根据需要动态调整屏幕刷新率，当你未设置屏幕刷新率时，屏幕刷新率默认为 90 Hz。